#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var ms = require("minimist");
var main_1 = require("./main");
var utils_1 = require("./utils");
if (require && require.main === module) {
    var args = ms(process.argv.slice(2));
    var project = args.project || args.p || process.cwd();
    if (!utils_1.isString(project)) {
        throw new Error('Project argument is invalid');
    }
    var projectPath = project.replace(/['"]/g, '');
    var projectConfigPath = '';
    if (!path.isAbsolute(project)) {
        projectPath = path.resolve(process.cwd(), projectPath);
    }
    if (utils_1.isFile(projectPath)) {
        projectConfigPath = path.resolve(projectPath);
        projectPath = path.dirname(project);
    }
    else if (utils_1.isDirectory(projectPath)) {
        projectConfigPath = path.resolve(projectPath, 'tsconfig.json');
    }
    else {
        throw new Error('A valid path is required to project directory or tsconfig!');
    }
    main_1.main(projectPath, projectConfigPath)
        .then(function () {
        console.log('Bundle completed successfully!');
        process.exit(0);
    })
        .catch(function (err) {
        console.error('Bundle halted!\n' + err);
        process.exit(1);
    });
}
//# sourceMappingURL=cli.js.map