"use strict";
/**
 * @license Typescript-Library-Bundler v0.0.11
 * (c) 2017 Amin Paks <amin.pakseresht@hotmail.com>
 * License: MIT
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var uglify = require("rollup-plugin-uglify");
var tsc_wrapped_1 = require("@angular/tsc-wrapped");
var preprocess_files_1 = require("./preprocess-files");
var tsc_1 = require("./tsc");
var rollup_1 = require("./rollup");
var config_helpers_1 = require("./config-helpers");
var utils_1 = require("./utils");
function main(projectPath, configFilePath) {
    return __awaiter(this, void 0, void 0, function () {
        var configFileDir, _a, configs, error, files, _b, compilerOptions, basePath, entryFile, packageFilePath, buildDir, defaultDestDir, destDir, packageConfigs, packageName, moduleId, moduleFilename, ngcBuildDir, ngcConfigPath, _c, bundlerOptions, _d, externals, outputES5Module, outputES6Module, rollupEntryFile, rollupES2015Config, transpileConfigES5, bundlesDir, outputUMDModule, rollupUMDConfig, outputMinifiedUMDModule, rollupMinifiedUMDConfig, outputTypings;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (utils_1.isNil(configFilePath)) {
                        configFilePath = path.resolve(projectPath, 'tsconfig.json');
                    }
                    configFileDir = path.dirname(configFilePath);
                    _a = config_helpers_1.parseConfigFile(configFilePath), configs = _a.configs, error = _a.error;
                    if (!utils_1.isNil(error)) {
                        throw new Error(error.messageText.toString());
                    }
                    files = configs.files, _b = configs.compilerOptions, compilerOptions = _b === void 0 ? {} : _b;
                    if (utils_1.isNil(files)) {
                        throw new Error('Project tsconfig must have files and point to the entry of library!');
                    }
                    if (!utils_1.isArray(files) || files.length !== 1) {
                        throw new Error('Project entry file must point to only one file!\n'
                            + 'Current files from tsconfig:\n' + files.join('\n'));
                    }
                    basePath = configFileDir;
                    entryFile = path.resolve(basePath, files.slice(0).shift());
                    packageFilePath = path.resolve(projectPath, 'package.json');
                    buildDir = path.resolve(projectPath, '.compile');
                    defaultDestDir = compilerOptions.outDir || 'dist';
                    destDir = path.resolve(configFileDir, defaultDestDir);
                    packageConfigs = config_helpers_1.readPackage(packageFilePath);
                    packageName = packageConfigs.name;
                    moduleId = config_helpers_1.getSafePackageName(packageName);
                    moduleFilename = moduleId + '.js';
                    if (utils_1.isNil(moduleId)) {
                        throw new Error("Package name includes invalid characters \"" + packageName + "\"!"); // `
                    }
                    if (utils_1.isNil(packageName)) {
                        throw new Error('Project package.json has no name entry!');
                    }
                    if (path.basename(entryFile, '.ts') === 'index') {
                        throw new Error('Project entry file cannot be named "index.ts"! try "public_api.ts" instead.');
                    }
                    // Clean up working directory
                    utils_1.ensureRemoveDir(buildDir);
                    utils_1.ensureRemoveDir(destDir);
                    utils_1.ensureMakeDir(buildDir);
                    // Preprocess typescript files
                    return [4 /*yield*/, preprocess_files_1.preprocessTSFiles(entryFile, buildDir, basePath)];
                case 1:
                    // Preprocess typescript files
                    _e.sent();
                    ngcBuildDir = path.resolve(buildDir, 'ngc-compiled');
                    ngcConfigPath = path.resolve(buildDir, 'tsconfig-ngc.json');
                    config_helpers_1.createNGCConfig(ngcConfigPath, moduleId, configs);
                    // Compile with NGC
                    return [4 /*yield*/, tsc_wrapped_1.main(ngcConfigPath, { basePath: buildDir })];
                case 2:
                    // Compile with NGC
                    _e.sent();
                    _c = configs.bundlerOptions, bundlerOptions = _c === void 0 ? {} : _c;
                    _d = bundlerOptions.externals, externals = _d === void 0 ? {} : _d;
                    outputES5Module = path.resolve(destDir, moduleId + '.es5.js');
                    outputES6Module = path.resolve(destDir, moduleFilename);
                    rollupEntryFile = path.resolve(ngcBuildDir, moduleFilename);
                    rollupES2015Config = rollup_1.defaultConfigs({
                        moduleEntry: rollupEntryFile,
                        moduleName: moduleId,
                        outputPath: outputES6Module,
                        customGlobals: externals,
                    });
                    return [4 /*yield*/, rollup_1.rollupBy(rollupES2015Config)];
                case 3:
                    _e.sent();
                    transpileConfigES5 = tsc_1.getTranspileOptions({
                        compilerOptions: { allowJs: true },
                        moduleName: moduleId,
                        fileName: moduleId,
                    });
                    return [4 /*yield*/, tsc_1.transpileModule(outputES6Module, transpileConfigES5, outputES5Module)];
                case 4:
                    _e.sent();
                    bundlesDir = path.resolve(destDir, 'bundles');
                    outputUMDModule = path.resolve(bundlesDir, moduleId + '.umd.js');
                    rollupUMDConfig = rollup_1.defaultConfigs({
                        format: 'umd',
                        moduleEntry: outputES5Module,
                        moduleName: moduleId,
                        outputPath: outputUMDModule,
                        customGlobals: externals,
                    });
                    return [4 /*yield*/, rollup_1.rollupBy(rollupUMDConfig)];
                case 5:
                    _e.sent();
                    outputMinifiedUMDModule = path.resolve(bundlesDir, moduleId + '.umd.min.js');
                    rollupMinifiedUMDConfig = rollup_1.defaultConfigs({
                        format: 'umd',
                        moduleEntry: outputES5Module,
                        moduleName: packageName,
                        outputPath: outputMinifiedUMDModule,
                        customGlobals: externals,
                        plugins: [uglify()],
                    });
                    return [4 /*yield*/, rollup_1.rollupBy(rollupMinifiedUMDConfig)];
                case 6:
                    _e.sent();
                    // Copy declarations and metadata files
                    return [4 /*yield*/, utils_1.copyFromTo({
                            pattern: '**/*(*.d.ts|*.metadata.json)',
                            rootDir: ngcBuildDir,
                            toDir: destDir,
                        })];
                case 7:
                    // Copy declarations and metadata files
                    _e.sent();
                    outputTypings = path.resolve(destDir, moduleId + '.d.ts');
                    config_helpers_1.validatePkgModuleEntries({
                        pkgMain: outputUMDModule,
                        pkgModule: outputES5Module,
                        pkgES2015: outputES6Module,
                        pkgTypings: outputTypings,
                    }, packageConfigs, projectPath);
                    return [2 /*return*/];
            }
        });
    });
}
exports.main = main;
//# sourceMappingURL=main.js.map