"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var utils_1 = require("../utils");
var css_tools_1 = require("./css-tools");
var less_render_1 = require("./less-render");
var sass_render_1 = require("./sass-render");
exports.InlineStyles = function (file) { return __awaiter(_this, void 0, void 0, function () {
    var styleUrlsRE, StyleUrlsMatchFullIndex, StyleUrlsMatchStylesKeyIndex, StyleUrlsMatchArrayIndex, styleUrlsArrayElementsRE, StyleUrlsArrayMatchFullIndex, StyleUrlsArrayMatchQuoteIndex, StyleUrlsArrayMatchFileIndex, content, styleUrlsMatch, styleUrlsArray, styleUrlsArrayReplacements, styleUrlsArrayElementMatch, styleFilename, styleFileExt, styleFilePath, styleContent, _a, lessResult, sassResult, quote, currentStyleUrlsArrayElementFull, currentStyleContentEscaped, currentStyleUrlsArrayElementReplacement, currentStyleUrlsFull, currentStyleUrlsStyleKey, currentStyleUrlsReplacement;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                styleUrlsRE = /(styleUrls\s*):\s*\[([^\]]+)\]/gi;
                StyleUrlsMatchFullIndex = 0;
                StyleUrlsMatchStylesKeyIndex = 1;
                StyleUrlsMatchArrayIndex = 2;
                styleUrlsArrayElementsRE = /([`'"])((?:(?!\1)[\s\S])+)\1/g;
                StyleUrlsArrayMatchFullIndex = 0;
                StyleUrlsArrayMatchQuoteIndex = 1;
                StyleUrlsArrayMatchFileIndex = 2;
                content = file.content;
                if (utils_1.isEmpty(content) || styleUrlsRE.test(content) === false) {
                    return [2 /*return*/, content];
                }
                styleUrlsRE.lastIndex = 0;
                _b.label = 1;
            case 1:
                if (!((styleUrlsMatch = styleUrlsRE.exec(content)) && !utils_1.isNil(styleUrlsMatch))) return [3 /*break*/, 11];
                styleUrlsArray = styleUrlsMatch[StyleUrlsMatchArrayIndex];
                styleUrlsArrayReplacements = styleUrlsArray;
                styleUrlsArrayElementMatch = void 0;
                _b.label = 2;
            case 2:
                if (!((styleUrlsArrayElementMatch = styleUrlsArrayElementsRE.exec(styleUrlsArray)) && !utils_1.isNil(styleUrlsArrayElementMatch))) return [3 /*break*/, 10];
                styleFilename = styleUrlsArrayElementMatch[StyleUrlsArrayMatchFileIndex];
                styleFileExt = path.extname(styleFilename).toLowerCase();
                styleFilePath = path.resolve(file.dirPath, styleFilename);
                if (!utils_1.isFile(styleFilePath)) {
                    return [3 /*break*/, 2];
                }
                styleContent = utils_1.readFile(styleFilePath);
                _a = styleFileExt;
                switch (_a) {
                    case '.less': return [3 /*break*/, 3];
                    case '.scss': return [3 /*break*/, 5];
                }
                return [3 /*break*/, 7];
            case 3: return [4 /*yield*/, less_render_1.renderLess(styleContent, file.dirPath, process.cwd())];
            case 4:
                lessResult = _b.sent();
                if (!utils_1.isEmpty(lessResult)) {
                    styleContent = lessResult;
                }
                return [3 /*break*/, 8];
            case 5: return [4 /*yield*/, sass_render_1.renderSass(styleContent, file.dirPath, process.cwd())];
            case 6:
                sassResult = _b.sent();
                if (!utils_1.isEmpty(sassResult)) {
                    styleContent = sassResult;
                }
                return [3 /*break*/, 8];
            case 7: return [3 /*break*/, 8];
            case 8: return [4 /*yield*/, css_tools_1.minifyCSS(styleContent)];
            case 9:
                styleContent = _b.sent();
                quote = styleUrlsArrayElementMatch[StyleUrlsArrayMatchQuoteIndex];
                currentStyleUrlsArrayElementFull = styleUrlsArrayElementMatch[StyleUrlsArrayMatchFullIndex];
                currentStyleContentEscaped = styleContent.replace(new RegExp(quote, 'g'), '\\' + quote);
                currentStyleUrlsArrayElementReplacement = currentStyleUrlsArrayElementFull.replace(styleFilename, currentStyleContentEscaped);
                styleUrlsArrayReplacements = styleUrlsArrayReplacements.replace(currentStyleUrlsArrayElementFull, currentStyleUrlsArrayElementReplacement);
                return [3 /*break*/, 2];
            case 10:
                currentStyleUrlsFull = styleUrlsMatch[StyleUrlsMatchFullIndex];
                currentStyleUrlsStyleKey = styleUrlsMatch[StyleUrlsMatchStylesKeyIndex];
                currentStyleUrlsReplacement = currentStyleUrlsFull.replace(currentStyleUrlsStyleKey, 'styles').replace(styleUrlsArray, styleUrlsArrayReplacements);
                content = content.replace(currentStyleUrlsFull, currentStyleUrlsReplacement);
                return [3 /*break*/, 1];
            case 11: return [2 /*return*/, content];
        }
    });
}); };
//# sourceMappingURL=inline-styles.js.map