"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var file_1 = require("./file");
var inline_styles_1 = require("./plugins/inline-styles");
var inline_template_1 = require("./plugins/inline-template");
function preprocessTSFiles(entryFilePath, destDir, baseDir) {
    return __awaiter(this, void 0, void 0, function () {
        var allFiles, plugins, copiedFiles, _i, allFiles_1, file, _a, plugins_1, plugin, newContent, currentPath, destPath, absDestPath;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, getFiles(entryFilePath, [])];
                case 1:
                    allFiles = _b.sent();
                    plugins = [inline_template_1.InlineTemplate, inline_styles_1.InlineStyles];
                    copiedFiles = [];
                    _i = 0, allFiles_1 = allFiles;
                    _b.label = 2;
                case 2:
                    if (!(_i < allFiles_1.length)) return [3 /*break*/, 8];
                    file = allFiles_1[_i];
                    _a = 0, plugins_1 = plugins;
                    _b.label = 3;
                case 3:
                    if (!(_a < plugins_1.length)) return [3 /*break*/, 6];
                    plugin = plugins_1[_a];
                    return [4 /*yield*/, plugin(file)];
                case 4:
                    newContent = _b.sent();
                    if (newContent != file.content) {
                        file.setContent(newContent);
                    }
                    _b.label = 5;
                case 5:
                    _a++;
                    return [3 /*break*/, 3];
                case 6:
                    currentPath = file.filePath;
                    destPath = currentPath.replace(baseDir + path.sep, '');
                    absDestPath = path.resolve(destDir, destPath);
                    file.copyTo(absDestPath);
                    copiedFiles.push(absDestPath);
                    _b.label = 7;
                case 7:
                    _i++;
                    return [3 /*break*/, 2];
                case 8: return [2 /*return*/, copiedFiles];
            }
        });
    });
}
exports.preprocessTSFiles = preprocessTSFiles;
function getFiles(entryFilePath, _excludeList) {
    return __awaiter(this, void 0, void 0, function () {
        var entryFile, excludeFromList, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    entryFile = new file_1.FileHandler(entryFilePath);
                    excludeFromList = [entryFilePath];
                    _b = (_a = [entryFile]).concat;
                    return [4 /*yield*/, entryFile.getImportees(excludeFromList)];
                case 1: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
            }
        });
    });
}
//# sourceMappingURL=preprocess-files.js.map