"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var nodeResolve = require("rollup-plugin-node-resolve");
var absModuleFix = require("rollup-plugin-absolute-module-fix");
var utils_1 = require("./utils");
var rollup_globals_1 = require("./rollup-globals");
var rollup_1 = require("rollup");
function defaultConfigs(_a) {
    var format = _a.format, moduleName = _a.moduleName, moduleEntry = _a.moduleEntry, outputPath = _a.outputPath, customGlobals = _a.customGlobals, plugins = _a.plugins;
    if (utils_1.isNil(customGlobals)) {
        customGlobals = {};
    }
    if (utils_1.isNil(plugins)) {
        plugins = [];
    }
    if (utils_1.isNil(format)) {
        format = 'es';
    }
    return {
        moduleName: moduleName,
        format: format,
        entry: moduleEntry,
        dest: outputPath,
        external: Object.keys(__assign({}, rollup_globals_1.GlobalModules, customGlobals)),
        globals: __assign({}, rollup_globals_1.GlobalModules, customGlobals),
        onwarn: function (warn) {
            if (warn.code !== 'THIS_IS_UNDEFINED') {
                console.warn("Rollup: " + warn.code + " -- " + warn.message);
            }
        },
        sourceMap: true,
        plugins: [
            nodeResolve({
                main: true,
                jsnext: true,
            }),
            absModuleFix(),
        ].concat(plugins),
    };
}
exports.defaultConfigs = defaultConfigs;
function rollupBy(configs) {
    return __awaiter(this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, rollup_1.rollup(configs)];
                case 1:
                    result = _a.sent();
                    return [4 /*yield*/, result.write(configs)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.rollupBy = rollupBy;
//# sourceMappingURL=rollup.js.map